Index: drivers/usb/aiptek.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/aiptek.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/aiptek.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/usb/aiptek.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -195,31 +792,410 @@
 {
 	struct aiptek *aiptek = dev->private;
 
-	if (!--aiptek->open)
+	if (!--aiptek->open_count)
 		usb_unlink_urb(aiptek->irq);
 }
 
+/*
+ * Send a command to the tablet. No reply is expected.
+ */
 static void
 aiptek_command(struct usb_device *dev, unsigned int ifnum,
 	       unsigned char command, unsigned char data)
 {
 	__u8 buf[3];
 
-	buf[0] = 4;
+	buf[0] = 2;
+	buf[1] = command;
+	buf[2] = data;
+
+	if (usb_set_report(dev, ifnum, 3, 2, buf, sizeof (buf)) != sizeof (buf)) {
+		dbg("aiptek_command failed, sending: 0x%02x 0x%02x", command,
+		    data);
+	}
+}
+
+/*
+ * Send a query to the tablet. This is done by sending the query stream
+ * first as a command, waiting a few milliseconds, then submitting the
+ * same stream as a query.
+ */
+static unsigned int
+aiptek_query(struct usb_device *dev, unsigned int ifnum,
+	     unsigned char command, unsigned char data)
+{
+	unsigned int ret;
+	__u8 buf[8];
+	buf[0] = 2;
 	buf[1] = command;
 	buf[2] = data;
 
-	if (usb_set_report(dev, ifnum, 3, 2, buf, 3) != 3) {
-		dbg("aiptek_command: 0x%x 0x%x\n", command, data);
+	aiptek_command(dev, ifnum, command, data);
+	wait_ms(400);
+
+	if (usb_get_report(dev, ifnum, 3, 2, buf, 3) < 3) {
+		dbg("aiptek_query failed: returns 0x%02x 0x%02x 0x%02x",
+		    buf[0], buf[1], buf[2]);
+		return 0;
+	}
+	ret = ((__u32) buf[1]) | ((__u32) buf[2] << 8);
+	return ret;
+}
+
+/*
+ * Program the tablet into either absolute or relative mode.
+ *
+ * We also get information about the tablet's size.
+ */
+static void
+aiptek_program_tablet(struct aiptek *aiptek)
+{
+	int modelCode, odmCode, firmwareCode;
+	int xResolution, yResolution, zResolution;
+
+	aiptek->diagnostic = AIPTEK_DIAGNOSTIC_NA;
+
+	// execute Resolution500LPI
+	aiptek_command(aiptek->usbdev, aiptek->ifnum, 0x18, 0x04);
+	// query getModelCode
+	modelCode = aiptek_query(aiptek->usbdev, aiptek->ifnum, 0x02, 0x00);
+	// query getODMCode
+	odmCode = aiptek_query(aiptek->usbdev, aiptek->ifnum, 0x03, 0x00);
+	// query getFirmwareCode
+	firmwareCode = aiptek_query(aiptek->usbdev, aiptek->ifnum, 0x04, 0x00);
+	// query getXextension
+	xResolution = aiptek_query(aiptek->usbdev, aiptek->ifnum, 0x01, 0x00);
+	// query getYextension
+	yResolution = aiptek_query(aiptek->usbdev, aiptek->ifnum, 0x01, 0x01);
+	// query getPressureLevels
+	zResolution = aiptek_query(aiptek->usbdev, aiptek->ifnum, 0x08, 0x00);
+
+	// Depending on whether we are in absolute or relative mode, we will
+	// do a switchToTablet(absolute) or switchToMouse(relative) command.
+	if (aiptek->coordinate_mode == AIPTEK_COORDINATE_ABSOLUTE_MODE) {
+		// execute switchToTablet
+		aiptek_command(aiptek->usbdev, aiptek->ifnum, 0x10, 0x01);
+	} else {
+		// execute switchToMouse
+		aiptek_command(aiptek->usbdev, aiptek->ifnum, 0x10, 0x00);
+	}
+	// This command enables the macro keys
+	aiptek_command(aiptek->usbdev, aiptek->ifnum, 0x11, 0x02);
+	// execute FilterOn
+	aiptek_command(aiptek->usbdev, aiptek->ifnum, 0x17, 0x00);
+	// execute AutoGainOn
+	aiptek_command(aiptek->usbdev, aiptek->ifnum, 0x12, 0xff);
+
+	aiptek->features->odmCode = odmCode;
+	aiptek->features->modelCode = modelCode & 0xff;
+	aiptek->features->firmwareCode = firmwareCode;
+	aiptek->features->pressure_max = zResolution;
+	aiptek->features->x_max = xResolution;
+	aiptek->features->y_max = yResolution;
+
+	aiptek->eventCount = 0;
+}
+
+#if defined(CONFIG_PROC_FS)
+/*
+ * This routine determines keywords and their associated values, and
+ * maps them to supported modes in this driver. It's input comes from
+ * aiptek_procfs_write().
+ */
+static void
+aiptek_procfs_parse(struct aiptek *aiptek, char *keyword, char *value)
+{
+	if (strcmp(keyword, "pointer") == 0) {
+		if (strcmp(value, "stylus") == 0) {
+			aiptek->pointer_mode = AIPTEK_POINTER_ONLY_STYLUS_MODE;
+		} else if (strcmp(value, "mouse") == 0) {
+			aiptek->pointer_mode = AIPTEK_POINTER_ONLY_MOUSE_MODE;
+		} else if (strcmp(value, "either") == 0) {
+			aiptek->pointer_mode = AIPTEK_POINTER_EITHER_MODE;
+		}
+	} else if (strcmp(keyword, "coordinate") == 0) {
+		if (strcmp(value, "relative") == 0) {
+			aiptek->coordinate_mode =
+			    AIPTEK_COORDINATE_RELATIVE_MODE;
+		} else if (strcmp(value, "absolute") == 0) {
+			aiptek->coordinate_mode =
+			    AIPTEK_COORDINATE_ABSOLUTE_MODE;
+		}
+	} else if (strcmp(keyword, "xtilt") == 0) {
+		if (strcmp(value, "disable") == 0) {
+			aiptek->xTilt = AIPTEK_TILT_DISABLE;
+		} else {
+			int x = (int) simple_strtol(value, 0, 10);
+			if (x >= AIPTEK_TILT_MIN && x <= AIPTEK_TILT_MAX)
+				aiptek->xTilt = x;
+		}
+	} else if (strcmp(keyword, "ytilt") == 0) {
+		if (strcmp(value, "disable") == 0) {
+			aiptek->yTilt = AIPTEK_TILT_DISABLE;
+		} else {
+			int y = (int) simple_strtol(value, 0, 10);
+			if (y >= AIPTEK_TILT_MIN && y <= AIPTEK_TILT_MAX)
+				aiptek->yTilt = y;
+		}
+	} else if (strcmp(keyword, "jitter") == 0) {
+		aiptek->jitterDelay = (int) simple_strtol(value, 0, 10);
+	} else if (strcmp(keyword, "tool") == 0) {
+		if (strcmp(value, "mouse") == 0) {
+			aiptek->tool_mode = AIPTEK_TOOL_BUTTON_MOUSE_MODE;
+		} else if (strcmp(value, "rubber") == 0) {
+			aiptek->tool_mode = AIPTEK_TOOL_BUTTON_RUBBER_MODE;
+		} else if (strcmp(value, "pencil") == 0) {
+			aiptek->tool_mode = AIPTEK_TOOL_BUTTON_PENCIL_MODE;
+		} else if (strcmp(value, "pen") == 0) {
+			aiptek->tool_mode = AIPTEK_TOOL_BUTTON_PEN_MODE;
+		} else if (strcmp(value, "brush") == 0) {
+			aiptek->tool_mode = AIPTEK_TOOL_BUTTON_BRUSH_MODE;
+		} else if (strcmp(value, "airbrush") == 0) {
+			aiptek->tool_mode = AIPTEK_TOOL_BUTTON_AIRBRUSH_MODE;
+		}
+	}
+}
+
+/*
+ * This routine reads the status of the aiptek driver, and makes it
+ * available as a procfs file. The description of the procfs file
+ * is at the top of this driver source code.
+ */
+static int
+aiptek_procfs_read(char *page, char **start, off_t offset, int count,
+		   int *eof, void *data)
+{
+	int len;
+	char *out = page;
+	struct aiptek *aiptek = data;
+
+	out +=
+	    sprintf(out, "Aiptek Tablet (%dx%d)\n",
+		    aiptek->features->x_max, aiptek->features->y_max);
+
+	out +=
+	    sprintf(out,
+		    "(USB VendorID 0x%04x, ProductID 0x%04x, ODMCode 0x%04x\n",
+		    aiptek->dev.idvendor, aiptek->dev.idproduct,
+		    aiptek->features->odmCode);
+	out +=
+	    sprintf(out, " ModelCode: 0x%02x, FirmwareCode: 0x%04x)\n",
+		    aiptek->features->modelCode,
+		    aiptek->features->firmwareCode);
+
+	out += sprintf(out, "on /dev/input/event%d\n", aiptek->dev.number);
+	out += sprintf(out, "pointer=%s\n",
+		       (aiptek->pointer_mode == AIPTEK_POINTER_ONLY_MOUSE_MODE
+			? "mouse"
+			: (aiptek->pointer_mode ==
+			   AIPTEK_POINTER_ONLY_STYLUS_MODE ? "stylus" :
+			   "either")));
+	out +=
+	    sprintf(out, "coordinate=%s\n",
+		    (aiptek->coordinate_mode ==
+		     AIPTEK_COORDINATE_RELATIVE_MODE ? "relative" :
+		     "absolute"));
+
+	out += sprintf(out, "tool=");
+	switch (aiptek->tool_mode) {
+	case AIPTEK_TOOL_BUTTON_MOUSE_MODE:
+		out += sprintf(out, "mouse\n");
+		break;
+
+	case AIPTEK_TOOL_BUTTON_RUBBER_MODE:
+		out += sprintf(out, "rubber\n");
+		break;
+
+	case AIPTEK_TOOL_BUTTON_PEN_MODE:
+		out += sprintf(out, "pen\n");
+		break;
+
+	case AIPTEK_TOOL_BUTTON_PENCIL_MODE:
+		out += sprintf(out, "pencil\n");
+		break;
+
+	case AIPTEK_TOOL_BUTTON_BRUSH_MODE:
+		out += sprintf(out, "brush\n");
+		break;
+
+	case AIPTEK_TOOL_BUTTON_AIRBRUSH_MODE:
+		out += sprintf(out, "airbrush\n");
+		break;
 	}
+
+	out += sprintf(out, "xtilt=");
+	if (aiptek->xTilt == AIPTEK_TILT_DISABLE) {
+		out += sprintf(out, "disable\n");
+	} else {
+		out += sprintf(out, "%d\n", aiptek->xTilt);
+	}
+
+	out += sprintf(out, "ytilt=");
+	if (aiptek->yTilt == AIPTEK_TILT_DISABLE) {
+		out += sprintf(out, "disable\n");
+	} else {
+		out += sprintf(out, "%d\n", aiptek->yTilt);
+	}
+
+	out += sprintf(out, "jitter=%d\n", aiptek->jitterDelay);
+
+	out += sprintf(out, "diagnostic=");
+	switch (aiptek->diagnostic) {
+	case AIPTEK_DIAGNOSTIC_NA:
+		out += sprintf(out, "none\n");
+		break;
+	case AIPTEK_DIAGNOSTIC_SENDING_RELATIVE_IN_ABSOLUTE:
+		out += sprintf(out, "tablet sending relative reports\n");
+		break;
+	case AIPTEK_DIAGNOSTIC_SENDING_ABSOLUTE_IN_RELATIVE:
+		out += sprintf(out, "tablet sending absolute reports\n");
+		break;
+	case AIPTEK_DIAGNOSTIC_TOOL_DISALLOWED:
+		out += sprintf(out, "tablet seeing reports from ");
+		if (aiptek->pointer_mode == AIPTEK_POINTER_ONLY_MOUSE_MODE)
+			out += sprintf(out, "stylus\n");
+		else
+			out += sprintf(out, "mouse\n");
+		break;
+	}
+
+	out += sprintf(out, "eventsReceived=%lu\n", aiptek->eventCount);
+
+	len = out - page;
+	len -= offset;
+	if (len < count) {
+		*eof = 1;
+		if (len <= 0) {
+			return 0;
+		}
+	} else {
+		len = count;
+	}
+
+	*start = page + offset;
+
+	return len;
 }
 
-static void*
+/*
+ * This routine permits the setting of driver parameters through a
+ * procfs file. Writing to the procfs file (/proc/driver/usb/aiptek),
+ * you can program the tablet's behavior. Parameters that can be programmed
+ * (and their legal values) are described at the top of this driver.
+ *
+ *
+ * This parser is order-insensitive, and supports one or many parameters
+ * to be sent in one write request. As many parameters as you may fit
+ * in 64 bytes; we only require that you separate them with \n's.
+ *
+ * Any command that is not understood by the parser is silently ignored.
+ */
+static int
+aiptek_procfs_write(struct file *file, const char *buffer, unsigned long count,
+		    void *data)
+{
+	char buf[64];
+	char *scan;
+	char *keyword = NULL;
+	char *value = NULL;
+	struct aiptek *aiptek = data;
+	int num;
+
+	num = (count < 64) ? count : 64;
+	if (copy_from_user(buf, buffer, num))
+		return -EFAULT;
+	buf[num] = '\0';
+
+	scan = buf;
+	while (*scan) {
+		if (*scan == '\n' || *scan == '\0') {
+			if (*scan == '\n') {
+				*scan = '\0';
+				scan++;
+			}
+			if (keyword && value) {
+				aiptek_procfs_parse(aiptek, keyword, value);
+			}
+			keyword = NULL;
+			value = NULL;
+			continue;
+		}
+
+		if (*scan != '=' && keyword == NULL) {
+			keyword = scan;
+		} else if (*scan == '=') {
+			*scan++ = '\0';
+			value = scan;
+		}
+		scan++;
+	}
+	// We're insensitive as to whether the buffer ended in a \n or not.
+	if (keyword && value) {
+		aiptek_procfs_parse(aiptek, keyword, value);
+	}
+
+	aiptek_program_tablet(aiptek);
+
+	return num;
+}
+
+/*
+ * This routine destroys our procfs device interface. This will occur
+ * when you remove the driver, either through rmmod or the hotplug system.
+ */
+static void
+destroy_procfs_file(struct aiptek *aiptek)
+{
+	if (aiptek->aiptekProcfsEntry)
+		remove_proc_entry("aiptek", aiptek->usbProcfsEntry);
+	if (aiptek->usbProcfsEntry)
+		remove_proc_entry("usb", proc_root_driver);
+
+	aiptek->usbProcfsEntry = NULL;
+	aiptek->aiptekProcfsEntry = NULL;
+}
+
+/*
+ * This routine builds the procfs file. The file is located at,
+ *      procfs/driver/usb/aiptek.
+ */
+static void
+create_procfs_file(struct aiptek *aiptek)
+{
+	// Make procfs/driver/usb directory
+	aiptek->usbProcfsEntry = create_proc_entry("usb", S_IFDIR,
+						   proc_root_driver);
+	if (!aiptek->usbProcfsEntry) {
+		dbg("create_procfs_file failed; no procfs/driver/usb control file.");
+		destroy_procfs_file(aiptek);
+		return;
+	}
+	aiptek->usbProcfsEntry->owner = THIS_MODULE;
+
+	// Make procfs/driver/usb/aiptek file
+	aiptek->aiptekProcfsEntry = create_proc_entry("aiptek",
+						      S_IFREG | S_IRUGO |
+						      S_IWUGO,
+						      aiptek->usbProcfsEntry);
+	if (!aiptek->aiptekProcfsEntry) {
+		dbg("create_procfs_file failed; no procfs/driver/usb control file.");
+		destroy_procfs_file(aiptek);
+		return;
+	}
+	aiptek->aiptekProcfsEntry->owner = THIS_MODULE;
+	aiptek->aiptekProcfsEntry->data = aiptek;
+	aiptek->aiptekProcfsEntry->read_proc = aiptek_procfs_read;
+	aiptek->aiptekProcfsEntry->write_proc = aiptek_procfs_write;
+}
+#endif
+
+static void *
 aiptek_probe(struct usb_device *dev, unsigned int ifnum,
 	     const struct usb_device_id *id)
 {
 	struct usb_endpoint_descriptor *endpoint;
 	struct aiptek *aiptek;
+	int i;
 
 	if (!(aiptek = kmalloc(sizeof (struct aiptek), GFP_KERNEL)))
 		return NULL;
@@ -231,37 +1207,78 @@
 		kfree(aiptek);
 		return NULL;
 	}
+	// This used to be meaningful, when we had a matrix of
+	// different models with statically-assigned different
+	// features. Now we ask the tablet about everything.
+
+	aiptek->features = aiptek_features;
+
+	// Reset the tablet. The tablet boots up in 'SwitchtoMouse'
+	// mode, which indicates relative coordinates. 'SwitchToTablet'
+	// infers absolute coordinates. (Ergo, mice are inferred to be
+	// relative-only devices, which is not true. A misnomer.)
+	// The routine we use, aiptek_program_tablet, has been generalized
+	// enough such that it's callable through the procfs interface.
+	// This is why we use struct aiptek throughout.
+	aiptek->usbdev = dev;
+	aiptek->ifnum = ifnum;
+	aiptek->pointer_mode = AIPTEK_POINTER_EITHER_MODE;
+	aiptek->coordinate_mode = AIPTEK_COORDINATE_ABSOLUTE_MODE;
+	aiptek->tool_mode = AIPTEK_TOOL_BUTTON_PEN_MODE;
+	aiptek->xTilt = AIPTEK_TILT_DISABLE;
+	aiptek->yTilt = AIPTEK_TILT_DISABLE;
+	aiptek->jitterDelay = AIPTEK_JITTER_DELAY_DEFAULT;
+
+#ifdef CONFIG_PROC_FS
+	create_procfs_file(aiptek);
+#endif
+
+	aiptek_program_tablet(aiptek);
+
+	aiptek->dev.evbit[0] |= BIT(EV_KEY)
+	    | BIT(EV_ABS)
+	    | BIT(EV_MSC);
+
+	aiptek->dev.absbit[0] |= BIT(ABS_X)
+	    | BIT(ABS_Y)
+	    | BIT(ABS_PRESSURE)
+	    | BIT(ABS_TILT_X)
+	    | BIT(ABS_TILT_Y)
+	    | BIT(ABS_MISC);
+
+	aiptek->dev.relbit[0] |= BIT(REL_X)
+	    | BIT(REL_Y)
+	    | BIT(REL_MISC);
+
+	// Set the macro keys up. They are discontiguous, so it's better
+	// to set the bitmask this way.
+
+	for (i = 0; i < sizeof (macroKeyEvents) / sizeof (macroKeyEvents[0]);
+	     ++i) {
+		set_bit(macroKeyEvents[i], aiptek->dev.keybit);
+	}
 
-	// Resolution500LPI
-	aiptek_command(dev, ifnum, 0x18, 0x04);
-
-	// SwitchToTablet
-	aiptek_command(dev, ifnum, 0x10, 0x01);
-
-	aiptek->features = aiptek_features + id->driver_info;
-
-	aiptek->dev.evbit[0] |= BIT(EV_KEY) | BIT(EV_ABS) | BIT(EV_MSC) |
-	    aiptek->features->evbit;
-
-	aiptek->dev.absbit[0] |= BIT(ABS_X) | BIT(ABS_Y) | BIT(ABS_PRESSURE) |
-	    BIT(ABS_MISC) | aiptek->features->absbit;
-
-	aiptek->dev.relbit[0] |= aiptek->features->relbit;
-
-	aiptek->dev.keybit[LONG(BTN_LEFT)] |= BIT(BTN_LEFT) | BIT(BTN_RIGHT) |
-	    BIT(BTN_MIDDLE) | aiptek->features->btnbit;
-
-	aiptek->dev.keybit[LONG(BTN_DIGI)] |= BIT(BTN_TOOL_PEN) |
-	    BIT(BTN_TOOL_MOUSE) | BIT(BTN_TOUCH) |
-	    BIT(BTN_STYLUS) | BIT(BTN_STYLUS2) | aiptek->features->digibit;
+	aiptek->dev.keybit[LONG(BTN_LEFT)] |= BIT(BTN_LEFT)
+	    | BIT(BTN_RIGHT)
+	    | BIT(BTN_MIDDLE);
+
+	aiptek->dev.keybit[LONG(BTN_DIGI)] |= BIT(BTN_TOOL_PEN)
+	    | BIT(BTN_TOOL_RUBBER)
+	    | BIT(BTN_TOOL_PENCIL)
+	    | BIT(BTN_TOOL_AIRBRUSH)
+	    | BIT(BTN_TOOL_BRUSH)
+	    | BIT(BTN_TOOL_MOUSE)
+	    | BIT(BTN_TOUCH)
+	    | BIT(BTN_STYLUS)
+	    | BIT(BTN_STYLUS2);
 
 	aiptek->dev.mscbit[0] = BIT(MSC_SERIAL);
 
 	aiptek->dev.absmax[ABS_X] = aiptek->features->x_max;
 	aiptek->dev.absmax[ABS_Y] = aiptek->features->y_max;
-	aiptek->dev.absmax[ABS_PRESSURE] = aiptek->features->pressure_max -
-	    aiptek->features->pressure_min;
-
+	aiptek->dev.absmax[ABS_PRESSURE] = aiptek->features->pressure_max;
+	aiptek->dev.absmax[ABS_TILT_X] = AIPTEK_TILT_MAX;
+	aiptek->dev.absmax[ABS_TILT_Y] = AIPTEK_TILT_MAX;
 	aiptek->dev.absfuzz[ABS_X] = 0;
 	aiptek->dev.absfuzz[ABS_Y] = 0;
 
@@ -278,28 +1295,31 @@
 
 	endpoint = dev->config[0].interface[ifnum].altsetting[0].endpoint + 0;
 
-	FILL_INT_URB(aiptek->irq,
-		  dev,
-		  usb_rcvintpipe(dev, endpoint->bEndpointAddress),
-		         aiptek->data,
-		  aiptek->features->pktlen,
-		         aiptek->features->irq,
-		  aiptek,
-		  endpoint->bInterval);
+	usb_fill_int_urb(aiptek->irq,
+			 dev,
+			 usb_rcvintpipe(dev, endpoint->bEndpointAddress),
+			 aiptek->data,
+			 aiptek->features->pktlen,
+			 aiptek->features->irq, aiptek, endpoint->bInterval);
 
 	input_register_device(&aiptek->dev);
 
 	printk(KERN_INFO "input%d: %s on usb%d:%d.%d\n",
-	       aiptek->dev.number, aiptek->features->name, dev->bus->busnum,
-	       dev->devnum, ifnum);
+	       aiptek->dev.number,
+	       aiptek->features->name, dev->bus->busnum, dev->devnum, ifnum);
 
 	return aiptek;
 }
 
+static struct usb_driver aiptek_driver;
+
 static void
 aiptek_disconnect(struct usb_device *dev, void *ptr)
 {
 	struct aiptek *aiptek = ptr;
+#ifdef CONFIG_PROC_FS
+	destroy_procfs_file(aiptek);
+#endif
 	usb_unlink_urb(aiptek->irq);
 	input_unregister_device(&aiptek->dev);
 	usb_free_urb(aiptek->irq);
@@ -317,7 +1337,7 @@
 aiptek_init(void)
 {
 	usb_register(&aiptek_driver);
-	info(DRIVER_VERSION " " DRIVER_AUTHOR);
+	info(DRIVER_VERSION ": " DRIVER_AUTHOR);
 	info(DRIVER_DESC);
 	return 0;
 }
Index: drivers/usb/audio.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/audio.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/audio.c	22 Jul 2004 19:49:47 -0000	1.1
+++ drivers/usb/audio.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -105,6 +105,8 @@
  *              functionality. Tested and used in production with the emagic emi 2|6 
  *              on PPC and Intel. Also fixed a few logic 'crash and burn' corner 
  *              cases.
+ * 2003-06-30:  Thomas Sailer
+ *              Fix SETTRIGGER non OSS API conformity
  */
 
 /*
@@ -279,23 +281,24 @@
 	unsigned int srate;
 	/* physical buffer */
 	unsigned char *sgbuf[NRSGBUF];
-	unsigned bufsize;
-	unsigned numfrag;
-	unsigned fragshift;
-	unsigned wrptr, rdptr;
-	unsigned total_bytes;
+	unsigned int bufsize;
+	unsigned int numfrag;
+	unsigned int fragshift;
+	unsigned int wrptr, rdptr;
+	unsigned int total_bytes;
 	int count;
-	unsigned error; /* over/underrun */
+	unsigned int error; /* over/underrun */
 	wait_queue_head_t wait;
 	/* redundant, but makes calculations easier */
-	unsigned fragsize;
-	unsigned dmasize;
+	unsigned int fragsize;
+	unsigned int dmasize;
 	/* OSS stuff */
-	unsigned mapped:1;
-	unsigned ready:1;
-	unsigned ossfragshift;
+	unsigned int mapped:1;
+	unsigned int ready:1;
+	unsigned int enabled:1;
+	unsigned int ossfragshift;
 	int ossmaxfrags;
-	unsigned subdivision;
+	unsigned int subdivision;
 };
 
 struct usb_audio_state;
@@ -562,6 +565,7 @@
 			break;
 	}
 	db->bufsize = nr << PAGE_SHIFT;
+	db->enabled = 1;
 	db->ready = 1;
 	dprintk((KERN_DEBUG "usbaudio: dmabuf_init bytepersec %d bufs %d ossfragshift %d ossmaxfrags %d "
 	         "fragshift %d fragsize %d numfrag %d dmasize %d bufsize %d fmt 0x%x srate %d\n",
@@ -1680,12 +1684,12 @@
 		    alts->endpoint[1].bmAttributes != 0x01 ||
 		    alts->endpoint[1].bSynchAddress != 0 ||
 		    alts->endpoint[1].bEndpointAddress != (alts->endpoint[0].bSynchAddress & 0x7f)) {
-			printk(KERN_ERR "usbaudio: device %d interface %d altsetting %d invalid synch pipe\n",
+			printk(KERN_WARNING "usbaudio: device %d interface %d altsetting %d claims adaptive in but has invalid synch pipe; treating as asynchronous in\n",
 			       dev->devnum, u->interface, fmt->altsetting);
-			return -1;
+		} else {
+			u->syncpipe = usb_sndisocpipe(dev, alts->endpoint[1].bEndpointAddress & 0xf);
+			u->syncinterval = alts->endpoint[1].bRefresh;
 		}
-		u->syncpipe = usb_sndisocpipe(dev, alts->endpoint[1].bEndpointAddress & 0xf);
-		u->syncinterval = alts->endpoint[1].bRefresh;
 	}
 	if (d->srate < fmt->sratelo)
 		d->srate = fmt->sratelo;
@@ -1775,12 +1779,12 @@
 		    alts->endpoint[1].bmAttributes != 0x01 ||
 		    alts->endpoint[1].bSynchAddress != 0 ||
 		    alts->endpoint[1].bEndpointAddress != (alts->endpoint[0].bSynchAddress | 0x80)) {
-			printk(KERN_ERR "usbaudio: device %d interface %d altsetting %d invalid synch pipe\n",
+			printk(KERN_WARNING "usbaudio: device %d interface %d altsetting %d claims asynch out but has invalid synch pipe; treating as adaptive out\n",
 			       dev->devnum, u->interface, fmt->altsetting);
-			return -1;
+		} else {
+			u->syncpipe = usb_rcvisocpipe(dev, alts->endpoint[1].bEndpointAddress & 0xf);
+			u->syncinterval = alts->endpoint[1].bRefresh;
 		}
-		u->syncpipe = usb_rcvisocpipe(dev, alts->endpoint[1].bEndpointAddress & 0xf);
-		u->syncinterval = alts->endpoint[1].bRefresh;
 	}
 	if (d->srate < fmt->sratelo)
 		d->srate = fmt->sratelo;
@@ -2299,7 +2303,7 @@
 		if (cnt > count)
 			cnt = count;
 		if (cnt <= 0) {
-			if (usbin_start(as)) {
+			if (as->usbin.dma.enabled && usbin_start(as)) {
 				if (!ret)
 					ret = -ENODEV;
 				break;
@@ -2332,6 +2336,11 @@
 		count -= cnt;
 		buffer += cnt;
 		ret += cnt;
+		if (as->usbin.dma.enabled && usbin_start(as)) {
+			if (!ret)
+				ret = -ENODEV;
+			break;
+		}
 	}
 	__set_current_state(TASK_RUNNING);
 	remove_wait_queue(&as->usbin.dma.wait, &wait);
@@ -2378,7 +2387,7 @@
 		if (cnt > count)
 			cnt = count;
 		if (cnt <= 0) {
-			if (usbout_start(as)) {
+			if (as->usbout.dma.enabled && usbout_start(as)) {
 				if (!ret)
 					ret = -ENODEV;
 				break;
@@ -2411,7 +2420,7 @@
 		count -= cnt;
 		buffer += cnt;
 		ret += cnt;
-		if (as->usbout.dma.count >= start_thr && usbout_start(as)) {
+		if (as->usbout.dma.enabled && as->usbout.dma.count >= start_thr && usbout_start(as)) {
 			if (!ret)
 				ret = -ENODEV;
 			break;
@@ -2616,19 +2625,25 @@
 			if (val & PCM_ENABLE_INPUT) {
 				if (!as->usbin.dma.ready && (ret = prog_dmabuf_in(as)))
 					return ret;
+				as->usbin.dma.enabled = 1;
 				if (usbin_start(as))
 					return -ENODEV;
-			} else
+			} else {
+				as->usbin.dma.enabled = 0;
 				usbin_stop(as);
+			}
 		}
 		if (file->f_mode & FMODE_WRITE) {
 			if (val & PCM_ENABLE_OUTPUT) {
 				if (!as->usbout.dma.ready && (ret = prog_dmabuf_out(as)))
 					return ret;
+				as->usbout.dma.enabled = 1;
 				if (usbout_start(as))
 					return -ENODEV;
-			} else
+			} else {
+				as->usbout.dma.enabled = 0;
 				usbout_stop(as);
+			}
 		}
 		return 0;
 
@@ -2827,10 +2842,14 @@
 		if (signal_pending(current))
 			return -ERESTARTSYS;
 	}
-	if (file->f_mode & FMODE_READ)
+	if (file->f_mode & FMODE_READ) {
 		as->usbin.dma.ossfragshift = as->usbin.dma.ossmaxfrags = as->usbin.dma.subdivision = 0;
-	if (file->f_mode & FMODE_WRITE)
+		as->usbin.dma.enabled = 1;
+	}
+	if (file->f_mode & FMODE_WRITE) {
 		as->usbout.dma.ossfragshift = as->usbout.dma.ossmaxfrags = as->usbout.dma.subdivision = 0;
+		as->usbout.dma.enabled = 1;
+	}
 	if (set_format(as, file->f_mode, ((minor & 0xf) == SND_DEV_DSP16) ? AFMT_S16_LE : AFMT_U8 /* AFMT_ULAW */, 8000)) {
 		up(&open_sem);
 		return -EIO;
Index: drivers/usb/auermain.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/auermain.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/auermain.c	22 Jul 2004 19:49:47 -0000	1.1
+++ drivers/usb/auermain.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -2,7 +2,7 @@
 /*
  *      auermain.c  --  Auerswald PBX/System Telephone usb driver.
  *
- *      Copyright (C) 2002  Wolfgang Mües (wolfgang@iksw-muees.de)
+ *      Copyright (C) 2002-2004  Wolfgang Mües (wolfgang@iksw-muees.de)
  *
  *      Very much code of this driver is borrowed from dabusb.c (Deti Fliegl)
  *      and from the USB Skeleton driver (Greg Kroah-Hartman). Thank you.
@@ -55,7 +55,7 @@
 
 /*-------------------------------------------------------------------*/
 /* Version Information */
-#define DRIVER_VERSION "1.2.3"
+#define DRIVER_VERSION "1.2.6"
 #define DRIVER_AUTHOR  "Wolfgang Mües <wolfgang@iksw-muees.de>"
 #define DRIVER_DESC    "Auerswald PBX/System Telephone usb driver"
 
@@ -828,9 +828,10 @@
 static struct usb_device_id auerswald_ids[] = {
 	{USB_DEVICE(ID_AUERSWALD, 0x00C0)},	/* COMpact 2104 USB/DSL */
 	{USB_DEVICE(ID_AUERSWALD, 0x00DB)},	/* COMpact 4410/2206 USB */
-	{USB_DEVICE(ID_AUERSWALD, 0x00DC)},	/* comming soon... */
-	{USB_DEVICE(ID_AUERSWALD, 0x00F1)},	/* Comfort 2000 System Telephone */
-	{USB_DEVICE(ID_AUERSWALD, 0x00F2)},	/* Comfort 1200 System Telephone */
+	{USB_DEVICE(ID_AUERSWALD, 0x00DC)},	/* COMpact 4406 DSL */
+	{USB_DEVICE(ID_AUERSWALD, 0x00DD)},	/* COMpact 2204 USB */
+	{USB_DEVICE(ID_AUERSWALD, 0x00F1)},	/* COMfort 2000 System Telephone */
+	{USB_DEVICE(ID_AUERSWALD, 0x00F2)},	/* COMfort 1200 System Telephone */
 	{}					/* Terminating entry */
 };
 
Index: drivers/usb/bluetooth.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/bluetooth.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/bluetooth.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/usb/bluetooth.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -1,8 +1,8 @@
 /*
  * bluetooth.c   Version 0.12
  *
- * Copyright (c) 2000, 2001 Greg Kroah-Hartman	<greg@kroah.com>
- * Copyright (c) 2000 Mark Douglas Corner	<mcorner@umich.edu>
+ * Copyright (C) 2000, 2001 Greg Kroah-Hartman	<greg@kroah.com>
+ * Copyright (C) 2000 Mark Douglas Corner	<mcorner@umich.edu>
  *
  * USB Bluetooth TTY driver, based on the Bluetooth Spec version 1.0B
  * 
Index: drivers/usb/brlvger.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/brlvger.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/brlvger.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/usb/brlvger.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -623,14 +623,14 @@
 			int firstpart = 6 - off;
 			
 #ifdef WRITE_DEBUG
-			dbg3("off: %d, rs: %d, count: %d, firstpart: %d",
+			dbg3("off: %lld, rs: %d, count: %d, firstpart: %d",
 			     off, rs, count, firstpart);
 #endif
 
 			firstpart = (firstpart < count) ? firstpart : count;
 
 #ifdef WRITE_DEBUG
-			dbg3("off: %d", off);
+			dbg3("off: %lld", off);
 			dbg3("firstpart: %d", firstpart);
 #endif
 
@@ -650,7 +650,7 @@
 			off +=2;
 
 #ifdef WRITE_DEBUG
-			dbg3("off: %d, rs: %d, count: %d, firstpart: %d, "
+			dbg3("off: %lld, rs: %d, count: %d, firstpart: %d, "
 				"written: %d", 	off, rs, count, firstpart, written);
 #endif
 		}
Index: drivers/usb/catc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/catc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/catc.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/usb/catc.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -42,6 +42,7 @@
 #include <linux/skbuff.h>
 #include <linux/spinlock.h>
 #include <linux/ethtool.h>
+#include <linux/crc32.h>
 #include <asm/bitops.h>
 #include <asm/uaccess.h>
 
@@ -62,6 +63,8 @@
 MODULE_DESCRIPTION(DRIVER_DESC);
 MODULE_LICENSE("GPL");
 
+static const char driver_name[] = "catc";
+
 /*
  * Some defines.
  */ 
@@ -596,20 +599,9 @@
  * Receive modes. Broadcast, Multicast, Promisc.
  */
 
-static inline u32 ether_crc_le(int cnt, unsigned char *addr)
-{
-	unsigned int crc = 0xffffffff;
-	u8 byte, idx, bit;
-	
-        for (idx = 0; idx < cnt; idx++)
-                for (byte = *addr++, bit = 0; bit < 8; bit++, byte >>= 1)
-                        crc = (crc >> 1) ^ (((crc ^ byte) & 1) ? 0xedb88320U : 0);
-	return crc;
-}
-
 static void catc_multicast(unsigned char *addr, u8 *multicast)
 {
-	unsigned int crc = ether_crc_le(6, addr);
+	u32 crc = ether_crc_le(6, addr);
 	multicast[(crc >> 3) & 0x3f] |= 1 << (crc & 7);
 }
 
@@ -674,7 +666,7 @@
         /* get driver info */
         case ETHTOOL_GDRVINFO: {
                 struct ethtool_drvinfo info = {ETHTOOL_GDRVINFO};
-                strncpy(info.driver, SHORT_DRIVER_DESC, ETHTOOL_BUSINFO_LEN);
+                strncpy(info.driver, driver_name, ETHTOOL_BUSINFO_LEN);
                 strncpy(info.version, DRIVER_VERSION, ETHTOOL_BUSINFO_LEN);
 		sprintf(tmp, "usb%d:%d", catc->usbdev->bus->busnum, catc->usbdev->devnum);
                 strncpy(info.bus_info, tmp,ETHTOOL_BUSINFO_LEN);
@@ -937,7 +929,7 @@
 MODULE_DEVICE_TABLE(usb, catc_id_table);
 
 static struct usb_driver catc_driver = {
-	name:		"catc",
+	name:		driver_name,
 	probe:		catc_probe,
 	disconnect:	catc_disconnect,
 	id_table:	catc_id_table,
Index: drivers/usb/dabusb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/dabusb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/dabusb.c	22 Jul 2004 19:49:47 -0000	1.1
+++ drivers/usb/dabusb.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -21,7 +21,7 @@
  *
  *
  *
- *  $Id: dabusb.c,v 1.1 2004/07/22 19:49:47 joff Exp $
+ *  $Id: dabusb.c,v 1.2 2004/08/04 01:29:52 joff Exp $
  *
  */
 
Index: drivers/usb/devices.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/devices.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/devices.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/usb/devices.c	4 Aug 2004 01:29:52 -0000	1.2
@@ -49,7 +49,7 @@
  *   Converted file reading routine to dump to buffer once
  *   per device, not per bus
  *
- * $Id: devices.c,v 1.1 2004/07/22 19:49:46 joff Exp $
+ * $Id: devices.c,v 1.2 2004/08/04 01:29:52 joff Exp $
  */
 
 #include <linux/fs.h>
